/* ***********************************************************
 * This file was automatically generated on 2017-05-11.      *
 *                                                           *
 * C# Bindings Version 2.1.14                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Passive infrared (PIR) motion sensor, 7m range
	/// </summary>
	public class BrickletMotionDetector : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 233;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Motion Detector Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_MOTION_DETECTED = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_MOTION_DETECTED = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_DETECTION_CYCLE_ENDED = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_STATUS_LED_CONFIG = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_STATUS_LED_CONFIG = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte MOTION_NOT_DETECTED = 0;

		/// <summary>
		/// </summary>
		public const byte MOTION_DETECTED = 1;

		/// <summary>
		/// </summary>
		public const byte STATUS_LED_CONFIG_OFF = 0;

		/// <summary>
		/// </summary>
		public const byte STATUS_LED_CONFIG_ON = 1;

		/// <summary>
		/// </summary>
		public const byte STATUS_LED_CONFIG_SHOW_STATUS = 2;


		/// <summary>
		///  This callback is called after a motion was detected.
		/// </summary>
		public event MotionDetectedEventHandler MotionDetectedCallback;
		/// <summary>
		/// </summary>
		public delegate void MotionDetectedEventHandler(BrickletMotionDetector sender);

		/// <summary>
		/// </summary>
		public event MotionDetectedEventHandler MotionDetected // for backward compatibility
		{
			add { MotionDetectedCallback += value; }
			remove { MotionDetectedCallback -= value; }
		}

		/// <summary>
		///  This callback is called when the detection cycle ended. When this
		///  callback is called, a new motion can be detected again after approximately 2
		///  seconds.
		/// </summary>
		public event DetectionCycleEndedEventHandler DetectionCycleEndedCallback;
		/// <summary>
		/// </summary>
		public delegate void DetectionCycleEndedEventHandler(BrickletMotionDetector sender);

		/// <summary>
		/// </summary>
		public event DetectionCycleEndedEventHandler DetectionCycleEnded // for backward compatibility
		{
			add { DetectionCycleEndedCallback += value; }
			remove { DetectionCycleEndedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletMotionDetector(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_MOTION_DETECTED] = new CallbackWrapper(OnMotionDetectedCallback);
			callbackWrappers[CALLBACK_DETECTION_CYCLE_ENDED] = new CallbackWrapper(OnDetectionCycleEndedCallback);

			responseExpected[FUNCTION_GET_MOTION_DETECTED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_STATUS_LED_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STATUS_LED_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_MOTION_DETECTED] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_DETECTION_CYCLE_ENDED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Returns 1 if a motion was detected. How long this returns 1 after a motion
		///  was detected can be adjusted with one of the small potentiometers on the
		///  Motion Detector Bricklet, see :ref:`here
		///  &lt;motion_detector_bricklet_sensitivity_delay_block_time&gt;`.
		///  
		///  There is also a blue LED on the Bricklet that is on as long as the Bricklet is
		///  in the "motion detected" state.
		/// </summary>
		public byte GetMotionDetected()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MOTION_DETECTED);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the status led configuration.
		///  
		///  By default the status LED turns on if a motion is detected and off is no motion
		///  is detected.
		///  
		///  You can also turn the LED permanently on/off.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void SetStatusLEDConfig(byte config)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_SET_STATUS_LED_CONFIG);
			LEConverter.To((byte)config, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletMotionDetector.SetStatusLEDConfig"/>.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public byte GetStatusLEDConfig()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STATUS_LED_CONFIG);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnMotionDetectedCallback(byte[] response)
		{
			var handler = MotionDetectedCallback;
			if(handler != null)
			{
				handler(this);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnDetectionCycleEndedCallback(byte[] response)
		{
			var handler = DetectionCycleEndedCallback;
			if(handler != null)
			{
				handler(this);
			}
		}
	}
}
