/* ***********************************************************
 * This file was automatically generated on 2017-05-11.      *
 *                                                           *
 * C# Bindings Version 2.1.14                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Four 7-segment displays with switchable colon
	/// </summary>
	public class BrickletSegmentDisplay4x7 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 237;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Segment Display 4x7 Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_SEGMENTS = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_SEGMENTS = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_START_COUNTER = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_COUNTER_VALUE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_COUNTER_FINISHED = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;



		/// <summary>
		///  This callback is triggered when the counter (see <see cref="Tinkerforge.BrickletSegmentDisplay4x7.StartCounter"/>) is
		///  finished.
		/// </summary>
		public event CounterFinishedEventHandler CounterFinishedCallback;
		/// <summary>
		/// </summary>
		public delegate void CounterFinishedEventHandler(BrickletSegmentDisplay4x7 sender);

		/// <summary>
		/// </summary>
		public event CounterFinishedEventHandler CounterFinished // for backward compatibility
		{
			add { CounterFinishedCallback += value; }
			remove { CounterFinishedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletSegmentDisplay4x7(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_COUNTER_FINISHED] = new CallbackWrapper(OnCounterFinishedCallback);

			responseExpected[FUNCTION_SET_SEGMENTS] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SEGMENTS] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_START_COUNTER] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_COUNTER_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_COUNTER_FINISHED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  The 7-segment display can be set with bitmaps. Every bit controls one
		///  segment:
		///  
		///  .. image:: /Images/Bricklets/bricklet_segment_display_4x7_bit_order.png
		///     :scale: 100 %
		///     :alt: Bit order of one segment
		///     :align: center
		///  
		///  For example to set a "5" you would want to activate segments 0, 2, 3, 5 and 6.
		///  This is represented by the number 0b01101101 = 0x6d = 109.
		///  
		///  The brightness can be set between 0 (dark) and 7 (bright). The colon
		///  parameter turns the colon of the display on or off.
		/// </summary>
		public void SetSegments(byte[] segments, byte brightness, bool colon)
		{
			byte[] request = CreateRequestPacket(14, FUNCTION_SET_SEGMENTS);
			LEConverter.To((byte[])segments, 8, 4, request);
			LEConverter.To((byte)brightness, 12, request);
			LEConverter.To((bool)colon, 13, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the segment, brightness and color data as set by
		///  <see cref="Tinkerforge.BrickletSegmentDisplay4x7.SetSegments"/>.
		/// </summary>
		public void GetSegments(out byte[] segments, out byte brightness, out bool colon)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SEGMENTS);

			byte[] response = SendRequest(request);

			segments = LEConverter.ByteArrayFrom(8, response, 4);
			brightness = LEConverter.ByteFrom(12, response);
			colon = LEConverter.BoolFrom(13, response);
		}

		/// <summary>
		///  Starts a counter with the *from* value that counts to the *to*
		///  value with the each step incremented by *increment*.
		///  The *length* of the increment is given in ms.
		///  
		///  Example: If you set *from* to 0, *to* to 100, *increment* to 1 and
		///  *length* to 1000, a counter that goes from 0 to 100 with one second
		///  pause between each increment will be started.
		///  
		///  The maximum values for *from*, *to* and *increment* is 9999,
		///  the minimum value is -999.
		///  
		///  Using a negative increment allows to count backwards.
		///  
		///  You can stop the counter at every time by calling <see cref="Tinkerforge.BrickletSegmentDisplay4x7.SetSegments"/>.
		/// </summary>
		public void StartCounter(short valueFrom, short valueTo, short increment, long length)
		{
			byte[] request = CreateRequestPacket(18, FUNCTION_START_COUNTER);
			LEConverter.To((short)valueFrom, 8, request);
			LEConverter.To((short)valueTo, 10, request);
			LEConverter.To((short)increment, 12, request);
			LEConverter.To((int)length, 14, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the counter value that is currently shown on the display.
		///  
		///  If there is no counter running a 0 will be returned.
		/// </summary>
		public int GetCounterValue()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_COUNTER_VALUE);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnCounterFinishedCallback(byte[] response)
		{
			var handler = CounterFinishedCallback;
			if(handler != null)
			{
				handler(this);
			}
		}
	}
}
